/*BluePup Bluetooth monitor for system tray*/
/*(c) Copyright Barry Kauler 2016, barryk.org*/
/*GPL license v3: /usr/share/doc/legal/ */
/*20160407 first release*/

#include <string.h>
#include <libintl.h>
#include <locale.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <glib/gstdio.h>
#include <dirent.h>
#include <errno.h>
#define _(STRING)    gettext(STRING)

GdkPixbuf *bluetoothon_pixbuf;
GdkPixbuf *bluetoothoff_pixbuf;
GError *gerror;
GtkStatusIcon *tray_icon;
gboolean Update(gpointer ptr);
int sysflag;
guint interval = 3000; /*update interval in milliseconds*/
char infomsg[256];

gboolean Update(gpointer ptr) {
 sysflag=system("pidof bluetoothd");
 /*i am thinking, to avoid timer always running, stop it once bluetooth enabled...*/
 if (sysflag==0) {
  gtk_status_icon_set_from_pixbuf(tray_icon,bluetoothon_pixbuf);
    //update tooltip...
    //gtk_status_icon_set_tooltip(tray_icon, infomsg);
  return 0; /*must return 1, if 0 timer stops*/
 }
 else {
  gtk_status_icon_set_from_pixbuf(tray_icon,bluetoothoff_pixbuf);
 }
 return 1; /*must return 1, if 0 timer stops*/
}

void tray_icon_on_click(GtkStatusIcon *status_icon, gpointer user_data)
{
 system("bluepup &");
 return 0;
}

static GtkStatusIcon *create_tray_icon() {

 tray_icon = gtk_status_icon_new();
 g_signal_connect(G_OBJECT(tray_icon), "activate", G_CALLBACK(tray_icon_on_click), NULL);
 
 bluetoothon_pixbuf=gdk_pixbuf_new_from_file("/usr/local/bluepup/bluetooth-on.xpm",&gerror);
 bluetoothoff_pixbuf=gdk_pixbuf_new_from_file("/usr/local/bluepup/bluetooth-off.xpm",&gerror);
 
 sysflag=system("pidof bluetoothd");
 if (sysflag==0) {
  gtk_status_icon_set_from_pixbuf(tray_icon,bluetoothon_pixbuf);
 }
 else {
  gtk_status_icon_set_from_pixbuf(tray_icon,bluetoothoff_pixbuf);
 }
 

 gtk_status_icon_set_tooltip(tray_icon,_("Click to run BluePup Bluetooth manager"));
 gtk_status_icon_set_visible(tray_icon, TRUE);
 return tray_icon;
}



int main(int argc, char **argv) {

    gtk_init(&argc, &argv);
    
    setlocale( LC_ALL, "" );
    bindtextdomain( "bluepup_tray", "/usr/share/locale" );
    textdomain( "bluepup_tray" );

    tray_icon = create_tray_icon();
        
    g_timeout_add(interval, Update, NULL);

    gtk_main();
    return 0;
}

